osl::move_action::NotKingOpenFilter< P, OrigAction > Struct Template Reference

相手の間接利きを止めている駒を動かさない More...

`#include <move_action.h>`

## Public Member Functions

| NotKingOpenFilter (const NumEffectState &s, OrigAction &action)
bool | isNotKingOpenMove (Ptype ptype, Square from, Square to)
void | simpleMove (Square from, Square to, Ptype ptype, bool isPromote, Player p, Move m)
void | unknownMove (Square from, Square to, Piece p1, Ptype ptype, bool isPromote, Player p, Move m)
void | dropMove (Square to, Ptype ptype, Player p, Move m)
| dropMoveが自殺手になることはない
void | simpleMove (Square from, Square to, Ptype ptype, bool isPromote, Player p)
void | unknownMove (Square from, Square to, Piece captured, Ptype ptype, bool isPromote, Player p)
void | dropMove (Square to, Ptype ptype, Player p)

## Public Attributes

const NumEffectState & | state
OrigAction & | action

## Detailed Description

template<Player P, class OrigAction>
struct osl::move_action::NotKingOpenFilter< P, OrigAction >

相手の間接利きを止めている駒を動かさない

Definition at line 160 of file move_action.h.

## Constructor & Destructor Documentation

## NotKingOpenFilter()

template<Player P, class OrigAction>

osl::move_action::NotKingOpenFilter< P, OrigAction >::NotKingOpenFilter | ( | const NumEffectState & | s,
|  | OrigAction & | action )

inline

Definition at line 165 of file move_action.h.

References action, and state.

## Member Function Documentation

## dropMove() [1/2]

template<Player P, class OrigAction>

void osl::move_action::NotKingOpenFilter< P, OrigAction >::dropMove | ( | Square | to,
|  | Ptype | ptype,
|  | Player | p )

inline

Definition at line 218 of file move_action.h.

References dropMove().

## dropMove() [2/2]

template<Player P, class OrigAction>

void osl::move_action::NotKingOpenFilter< P, OrigAction >::dropMove | ( | Square | to,
|  | Ptype | ptype,
|  | Player | p,
|  | Move | m )

inline

dropMoveが自殺手になることはない

Definition at line 196 of file move_action.h.

References action.

Referenced by dropMove().

## isNotKingOpenMove()

template<Player P, class OrigAction>

bool osl::move_action::NotKingOpenFilter< P, OrigAction >::isNotKingOpenMove | ( | Ptype | ptype,
|  | Square | from,
|  | Square | to )

inline

Definition at line 168 of file move_action.h.

References osl::move_classifier::KingOpenMove< P >::isMember(), and state.

Referenced by simpleMove(), and unknownMove().

## simpleMove() [1/2]

template<Player P, class OrigAction>

void osl::move_action::NotKingOpenFilter< P, OrigAction >::simpleMove | ( | Square | from,
|  | Square | to,
|  | Ptype | ptype,
|  | bool | isPromote,
|  | Player | p )

inline

Definition at line 206 of file move_action.h.

References osl::PTYPE_EMPTY, and simpleMove().

## simpleMove() [2/2]

template<Player P, class OrigAction>

void osl::move_action::NotKingOpenFilter< P, OrigAction >::simpleMove | ( | Square | from,
|  | Square | to,
|  | Ptype | ptype,
|  | bool | isPromote,
|  | Player | p,
|  | Move | m )

inline

Definition at line 172 of file move_action.h.

References action, and isNotKingOpenMove().

Referenced by simpleMove().

## unknownMove() [1/2]

template<Player P, class OrigAction>

void osl::move_action::NotKingOpenFilter< P, OrigAction >::unknownMove | ( | Square | from,
|  | Square | to,
|  | Piece | captured,
|  | Ptype | ptype,
|  | bool | isPromote,
|  | Player | p )

inline

Definition at line 212 of file move_action.h.

References osl::captured(), and unknownMove().

## unknownMove() [2/2]

template<Player P, class OrigAction>

void osl::move_action::NotKingOpenFilter< P, OrigAction >::unknownMove | ( | Square | from,
|  | Square | to,
|  | Piece | p1,
|  | Ptype | ptype,
|  | bool | isPromote,
|  | Player | p,
|  | Move | m )

inline

Definition at line 183 of file move_action.h.

References action, and isNotKingOpenMove().

Referenced by unknownMove().

## Member Data Documentation

## action

template<Player P, class OrigAction>

OrigAction& osl::move_action::NotKingOpenFilter< P, OrigAction >::action

Definition at line 163 of file move_action.h.

Referenced by dropMove(), NotKingOpenFilter(), simpleMove(), and unknownMove().

## state

template<Player P, class OrigAction>

const NumEffectState& osl::move_action::NotKingOpenFilter< P, OrigAction >::state

Definition at line 162 of file move_action.h.

Referenced by isNotKingOpenMove(), and NotKingOpenFilter().

The documentation for this struct was generated from the following file:

- move_action.h